#ifndef _USB2885_DEVICE_
#define _USB2885_DEVICE_

#include<windows.h>

#define USB2885_MAX_AI_CHANNELS	6 // ֧6·ģͨ

//***********************************************************
// ADɼĲṹ
typedef struct _USB2885_PARA_AD
{
	LONG bChannelArray[USB2885_MAX_AI_CHANNELS];	// ͨѡУֱ6ͨ=TRUEʾͨ򲻲
	LONG Gains[USB2885_MAX_AI_CHANNELS];			// 
	LONG InputRange;		// ģѡ
	LONG Frequency;         // ɼƵ,λΪHz, [1000, 250000]
	LONG TriggerMode;		// ģʽѡ
	LONG TriggerSource;		// Դѡ
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG TrigLevelVolt;		// ƽ(̰ģ)
	LONG TrigWindow;		// uS,[50,1638]
	LONG ClockSource;		// ʱԴѡ(/ʱԴ)
	LONG bClockOutput;      // ʱCLKOUT,=TRUE:ʱ, =FALSE:ֹʱ
} USB2885_PARA_AD, *PUSB2885_PARA_AD;

//***********************************************************
// ADUSB2885_PARA_ADеGains[x]ʹõӲѡ
const long USB2885_GAINS_1MULT			= 0x00; // 1
const long USB2885_GAINS_2MULT			= 0x01; // 2
const long USB2885_GAINS_4MULT			= 0x02; // 4
const long USB2885_GAINS_8MULT			= 0x03; // 8

//***********************************************************
// ADӲUSB2885_PARA_ADеInputRangeʹõѡ
const long USB2885_INPUT_N10000_P10000mV= 0x00; // 10000mV
const long USB2885_INPUT_N5000_P5000mV	= 0x01; // 5000mV

//***********************************************************
// ADӲUSB2885_PARA_ADеTriggerModeԱʹôģʽѡ
const long USB2885_TRIGMODE_EDGE		= 0x00; // ش
const long USB2885_TRIGMODE_PULSE		= 0x01; // ƽ

//***********************************************************
// ADӲUSB2885_PARA_ADеTriggerSourceԴźʹõѡ
const long USB2885_TRIGMODE_SOFT		= 0x00; // 
const long USB2885_TRIGSRC_DTR			= 0x01; // ѡDTRΪԴ
const long USB2885_TRIGSRC_ATR			= 0x02; // ѡATRΪԴ
const long USB2885_TRIGSRC_TRIGGER		= 0x03; // TriggerźŴڶ࿨ͬ

//***********************************************************
// ADӲUSB2885_PARA_ADеTriggerDirʹõѡ
const long USB2885_TRIGDIR_NEGATIVE		= 0x00; // 򴥷(͵ƽ/½ش)
const long USB2885_TRIGDIR_POSITIVE		= 0x01; // 򴥷(ߵƽ/ش)
const long USB2885_TRIGDIR_POSIT_NEGAT	= 0x02; // 򴥷(/͵ƽ/½ش)

//***********************************************************
// ADӲUSB2885_PARA_ADеClockSourceʱԴʹõѡ
const long USB2885_CLOCKSRC_IN			= 0x00; // ڲʱӶʱ
const long USB2885_CLOCKSRC_OUT			= 0x01; // ⲿʱӶʱ(ʹCN1ϵCLKINź)

//*************************************************************************************
// ADʵӲ
typedef struct _USB2885_STATUS_AD     
{
	LONG bADEanble;	// ADǷѾʹܣ=TRUE:ʾʹܣ=FALSE:ʾδʹ
	LONG bTrigger;  // ADǷ񱻴=TRUE:ʾѱ=FALSE:ʾδ
	LONG bHalf;		// ɼǷѴ=TRUE:ʾѰ=FALSE:ʾδ
} USB2885_STATUS_AD, *PUSB2885_STATUS_AD;

//***********************************************************
// ӿ
#ifndef _USB2885_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	HANDLE DEVAPI FAR PASCAL USB2885_CreateDevice(int DeviceLgcID = 0); // 豸(úʹϵͳ߼豸ID
	HANDLE DEVAPI FAR PASCAL USB2885_CreateDeviceEx(int DevicePhysID); // ʹID豸
	BOOL DEVAPI FAR PASCAL USB2885_GetDeviceCurrentID(HANDLE hDevice, PLONG DevicePhysID); // ȡõǰ豸ID
	BOOL DEVAPI FAR PASCAL USB2885_SetDevicePhysID(HANDLE hDevice, LONG DevicePhysID); // õǰ豸ID,ID[0~255],ϵ
	BOOL DEVAPI FAR PASCAL USB2885_ResetDevice(HANDLE hDevice);		 // λUSB豸
    BOOL DEVAPI FAR PASCAL USB2885_ReleaseDevice(HANDLE hDevice);    // 豸

	//####################### ADݶȡ #################################
	BOOL DEVAPI FAR PASCAL USB2885_ADCalibration(				// ADԶУ׼
									HANDLE hDevice);			// 豸,CreateDevice
	
    BOOL DEVAPI FAR PASCAL USB2885_InitDeviceAD(				// ʼ豸,TRUE,豸̿ʼ.
									HANDLE hDevice,				// 豸,ӦCreateDevice
									PUSB2885_PARA_AD pADPara);  // Ӳ, ڴ˺оӲ״̬	

	BOOL DEVAPI FAR PASCAL USB2885_StartDeviceAD(				// ڳʼ֮豸
									HANDLE hDevice);			// 豸

	BOOL DEVAPI FAR PASCAL USB2885_StopDeviceAD(				// 豸֮ͣ豸
									HANDLE hDevice);			// 豸

    BOOL DEVAPI FAR PASCAL USB2885_ReadDeviceAD(				// ʼ豸󣬼ô˺ȡ豸ϵAD
									HANDLE hDevice,				// 豸,ӦCreateDevice
									USHORT ADBuffer[],			// ڽݵû
									LONG nReadSizeWords,		// ȡADݵĳ()
									PLONG nRetSizeWords,		// ʵʷݵĳ(),
									BOOL bEnoughRtn = TRUE,		// TRUEȡ0FALSE:ȡʵʵ
									PLONG nSurplusWords = NULL);// FIFOʣ

    BOOL DEVAPI FAR PASCAL USB2885_ReleaseDeviceAD( HANDLE hDevice); // ֹͣADɼͷADռԴ

   	//################# ADӲ ########################	
	BOOL DEVAPI FAR PASCAL USB2885_SaveParaAD(HANDLE hDevice, PUSB2885_PARA_AD pADPara);  
    BOOL DEVAPI FAR PASCAL USB2885_LoadParaAD(HANDLE hDevice, PUSB2885_PARA_AD pADPara);
    BOOL DEVAPI FAR PASCAL USB2885_ResetParaAD(HANDLE hDevice, PUSB2885_PARA_AD pADPara); // ADָĬֵ

	//####################### I/O #################################
	BOOL DEVAPI FAR PASCAL USB2885_GetDeviceDI(				// ȡÿ״̬     
									HANDLE hDevice,				// 豸,ӦCreateDevice								        
									BYTE bDISts[16]);			// ״̬(ע: 붨Ϊ16ֽԪص)

	BOOL DEVAPI FAR PASCAL USB2885_SetDeviceDO(				// ״̬
									HANDLE hDevice,				// 豸,ӦCreateDevice								        
									BYTE bDOSts[16]);			// ״̬(ע: 붨Ϊ16ֽԪص)

	//############################################################################
	BOOL DEVAPI FAR PASCAL USB2885_GetDevVersion(				// ȡ豸̼汾
									HANDLE hDevice,				// 豸,CreateDevice
									PULONG pulFmwVersion,		// ̼汾
									PULONG pulDriverVersion);	// 汾


	//############################ ̲߳ ################################
	HANDLE DEVAPI FAR PASCAL USB2885_CreateSystemEvent(void); 	// ںϵͳ¼
	BOOL DEVAPI FAR PASCAL USB2885_ReleaseSystemEvent(HANDLE hEvent); // ͷں¼

#ifdef __cplusplus
}
#endif

// Զ
#ifndef _USB2885_DRIVER_
#ifndef _WIN64
#pragma comment(lib, "USB2885_32.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with USB2885_32.dll...")
#pragma message("======== Successfully linked with USB2885_32.dll")
#else
#pragma comment(lib, "USB2885_64.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with USB2885_64.dll...")
#pragma message("======== Successfully linked with USB2885_64.dll")
#endif

#endif

#endif; // _USB2885_DEVICE_